/* Generate a TCP packet
 * with a FIN flag and pass it through a raw socket.
 * 
 * Thamer Al-Herbish shadows@whitefang.com
 */

#include <stdlib.h>
#include <stdio.h>

#include <sys/types.h>
#include <sys/socket.h>

#include <netinet/in.h>
#include <arpa/inet.h>

#include <netinet/in_systm.h>

#if defined(LINUX)
#include <linux/ip.h>
#include <linux/tcp.h>
#else
#include <netinet/ip.h>
#include <netinet/tcp.h>
#endif

#include <string.h>
#include <unistd.h>
#include <time.h>

#include <rawsock_utils.h>

int main(int argc,char *argv[])
{
  unsigned char packet[
		       sizeof(struct iphdr) +
		       sizeof(struct tcphdr) + 960
	  ];
  struct sockaddr_in mysocket;
  unsigned short sport, dport;
  struct in_addr saddr, daddr;
  struct tcphdr *tcp;
  unsigned long count = 0;
  unsigned long seq = 0;
  unsigned long ack = 0;
  int sockd, on = 1;

  int i;
  char b_ack = 0;
  char b_fin = 0;
  char b_rst = 0;

  if(argc < 5)  {
    fprintf(stderr,"usage: %s source_port source_address dest_port dest_address\n",
	    argv[0]);
    fprintf(stderr,"       [PacketCount#] [Ack] [Fin] [Rst] [Seq# [Ack#]]\n");
    exit(1);
  }
  
  sport = (unsigned short)atoi(argv[1]);
  saddr.s_addr = inet_addr(argv[2]);
  
  dport = (unsigned short)atoi(argv[3]);
  daddr.s_addr = inet_addr(argv[4]);
 
  for(i = 5; i < argc; i++) {
    switch(*argv[i]) {
    case 'A':
    case 'a':
      b_ack = 1;
      break;
    case 'F':
    case 'f':
      b_fin = 1;
      break;
    case 'R':
    case 'r':
      b_rst = 1;
      break;
    case '0': case '1': case '2': case '3': case '4':
    case '5': case '6': case '7': case '8': case '9':
      if (count == 0) {
	count = strtoul(argv[i], NULL, 10);
      }
      else if (seq == 0) {
	seq = strtoul(argv[i], NULL, 10);
      }
      else if (ack == 0) {
	ack = strtoul(argv[i], NULL, 10);
      }
      break;
    default:
      break;
    }
  }

  if((sockd = socket(AF_INET,SOCK_RAW,IPPROTO_RAW)) < 0)  {
    perror("socket");
    exit(1);
  }
  
  if(setsockopt(sockd,IPPROTO_IP,IP_HDRINCL,(char *)&on,sizeof(on)) < 0)  {
    perror("setsockopt");
    exit(1);
  }
  
  /* Very bad random sequence number generator */
  
  /* srand(getpid()); *****/
  
  /* seq = rand()%time(NULL); *****/
  /* ack = rand()%time(NULL); *****/

  if (seq == 0) seq = 500000;
  if (ack == 0) ack = 400000;

  memset(&mysocket,'\0',sizeof(mysocket));
  mysocket.sin_family = AF_INET;
  mysocket.sin_port = htons(dport);
  mysocket.sin_addr = daddr;

  ip_gen(packet,IPPROTO_TCP,saddr,daddr,sizeof(packet));
  
  tcp = (struct tcphdr *)(packet + sizeof(struct iphdr));

  for(i = sizeof(struct iphdr) + sizeof(struct tcphdr);
      i < sizeof(packet);) { /* Mark the data area */
	  packet[i++] = 0xCC;
	  packet[i++] = 0x55;
  }

  for(i = 0; i < count; i++) {

  tcp_genx((char *)tcp,sport,dport,seq,ack,b_ack,b_fin,b_rst);
  tcp->check = trans_check(IPPROTO_TCP,(char *)tcp,
			   sizeof(struct tcphdr),
			   saddr,
			   daddr);
  
  if(sendto(sockd,&packet,sizeof(packet),0x0,(struct sockaddr *)&mysocket,
	    sizeof(mysocket)) != sizeof(packet))  {
    perror("sendto");
    exit(1);
  }
  seq++;
  }
  
  exit(0);
}
